;============================================
; Child window test bed (version 0)
;
; attempt to fix problems w/using child window for painting
;============================================


	INCLUDE	\masm32\include\masm32rt.inc

;============================================
; Defines, macros, prototypes, etc.
;============================================

WinMain			PROTO :DWORD
DrawCurve		PROTO :HANDLE

$mainWindowWidth	EQU 600
$mainWindowHeight	EQU 600

$toolbarWidth		EQU 192
$toolbarHeight		EQU 24

$numToolbarButtons	EQU 8

$toolbarBitmapID	EQU 500

;===== Window styles: =====
$mainWinAttrs		EQU WS_OVERLAPPEDWINDOW OR WS_CLIPCHILDREN OR WS_VISIBLE
$childWinAttrs		EQU WS_CHILD OR WS_CLIPSIBLINGS OR WS_VISIBLE
$toolbarAttrs		EQU WS_CHILD OR WS_CLIPSIBLINGS OR WS_VISIBLE OR WS_BORDER \
				OR TBSTYLE_LIST OR TBSTYLE_TOOLTIPS

$BTNstates		EQU TBSTATE_ENABLED

$buttonWidth		EQU 24
$buttonHeight		EQU 24

;===== Toolbar button IDs: =====
$TBbutton1		EQU  1500
$TBbutton2		EQU  1501
$TBbutton3		EQU  1502
$TBbutton4		EQU  1503
$TBbutton5		EQU  1504
$TBbutton6		EQU  1505
$TBbutton7		EQU  1506
$TBbutton8		EQU  1507

;===== Window background colors: =====
$bkRED			EQU 254
$bkGRN			EQU 243
$bkBLUE			EQU 199

$BkColor		EQU $bkRED OR ($bkGRN SHL 8) OR ($bkBLUE SHL 16)
$white			EQU 255 OR (255 SHL 8) OR (255 SHL 16)

;============================================
; HERE BE DATA
;============================================
.data

InstanceHandle		HWND ?
MainWinHandle		HWND ?
ChildWinHandle		HWND NULL
ToolbarHandle		HWND ?


ToolTipTextPtrs		DD BTN1text, BTN2text, BTN3text, BTN4text
			DD BTN5text, BTN6text, BTN7text, BTN8text

CCinitStruct		INITCOMMONCONTROLSEX <SIZEOF INITCOMMONCONTROLSEX, ICC_BAR_CLASSES>

;===== Toolbar button (TBBUTTON) structures:

ToolbarButtonStructs	LABEL DWORD
	TBBUTTON <0, $TBbutton1, $BTNstates, BTNS_BUTTON, 0, NULL, NULL>
	TBBUTTON <1, $TBbutton2, $BTNstates, BTNS_BUTTON, 0, NULL, NULL>
	TBBUTTON <2, $TBbutton3, $BTNstates, BTNS_BUTTON, 0, NULL, NULL>
	TBBUTTON <3, $TBbutton4, $BTNstates, BTNS_BUTTON, 0, NULL, NULL>
	TBBUTTON <4, $TBbutton5, $BTNstates, BTNS_BUTTON, 0, NULL, NULL>
	TBBUTTON <5, $TBbutton6, $BTNstates, BTNS_BUTTON, 0, NULL, NULL>
	TBBUTTON <6, $TBbutton7, $BTNstates, BTNS_BUTTON, 0, NULL, NULL>
	TBBUTTON <7, $TBbutton8, $BTNstates, BTNS_BUTTON, 0, NULL, NULL>

ToolbarAddBitmapStruct	TBADDBITMAP <0, $toolbarBitmapID>

OK2paintFlag		DW FALSE

MainClassName		DB "childtest", 0
ToolbarClassName	DB "ToolbarWindow32", 0
ChildClassName		DB "DaChild", 0

MainTitleText		DB "Child Window Test", 0

BTN1text		DB "whole note", 0
BTN2text		DB "half note", 0
BTN3text		DB "quarter note", 0
BTN4text		DB "8th note", 0
BTN5text		DB "whole rest", 0
BTN6text		DB "half rest", 0
BTN7text		DB "quarter rest", 0
BTN8text		DB "8th rest", 0

MainText		DB "This text is being drawn in the main window", 0
ChildText		DB "THIS TEXT GOES IN THE CHILD WINDOW", 0

;============================================
; CODE LIVES HERE
;============================================
.code


start:
	INVOKE	GetModuleHandle, NULL
	MOV	InstanceHandle, EAX

	INVOKE	WinMain, EAX
	INVOKE	ExitProcess, EAX


;====================================================================
; Mainline proc
;====================================================================

WinMain	PROC hInst:DWORD
	LOCAL	wc:WNDCLASSEX, msg:MSG, brush:HBRUSH, wX:DWORD, wY:DWORD
	LOCAL	lf:LOGFONT, hDC:HDC, gpRect:RECT, gpRect2:RECT

	INVOKE	InitCommonControlsEx, OFFSET CCinitStruct

; Create  brush to set background color:
	INVOKE	CreateSolidBrush, $BkColor
	MOV	brush, EAX

; Register class for parent window:
	MOV	wc.cbSize, SIZEOF WNDCLASSEX
	MOV	wc.style,  CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
	MOV	wc.lpfnWndProc, OFFSET MainWindowProc
	MOV	wc.cbClsExtra, NULL
	MOV	wc.cbWndExtra, NULL
	MOV	EAX, hInst
	MOV	wc.hInstance, EAX
	MOV	EAX, brush
	MOV	wc.hbrBackground, EAX
	MOV	wc.lpszMenuName,  NULL
	MOV	wc.lpszClassName, OFFSET MainClassName
	MOV	wc.hIcon, NULL
	INVOKE	LoadCursor, NULL, IDC_ARROW
	MOV	wc.hCursor, EAX
	MOV	wc.hIconSm, 0
	INVOKE	RegisterClassEx, ADDR wc

; Register class for child window:
	MOV	wc.lpfnWndProc, OFFSET ChildWindowProc
	MOV	wc.lpszClassName, OFFSET ChildClassName
	INVOKE	RegisterClassEx, ADDR wc

	INVOKE	GetSystemMetrics, SM_CXSCREEN
	MOV	EDX, $mainWindowWidth
	CALL	CenterDim
	MOV	wX, EAX
	INVOKE	GetSystemMetrics, SM_CYSCREEN
	MOV	EDX, $mainWindowHeight
	CALL	CenterDim
	MOV	wY, EAX

; Create our main window:
	INVOKE	CreateWindowEx, WS_EX_OVERLAPPEDWINDOW, ADDR MainClassName, ADDR MainTitleText,
		$mainWinAttrs, wX, wY, $mainWindowWidth, $mainWindowHeight,
		NULL, NULL, hInst, NULL

	MOV	MainWinHandle, EAX
	INVOKE	ShowWindow, EAX, SW_SHOWNORMAL

; Create toolbar window:
	INVOKE	CreateWindowEx, WS_EX_OVERLAPPEDWINDOW, ADDR ToolbarClassName, NULL,
		$toolbarAttrs, 0, 0, $toolbarWidth, $toolbarHeight,
		MainWinHandle, NULL, hInst, NULL
	MOV	ToolbarHandle, EAX

; Set up toolbar:
	INVOKE	SendMessage, ToolbarHandle, TB_BUTTONSTRUCTSIZE, SIZEOF TBBUTTON, 0
	INVOKE	SendMessage, ToolbarHandle, TB_SETBITMAPSIZE, 0, $buttonWidth OR ($buttonHeight SHL 16)
	MOV	EAX, InstanceHandle
	MOV	ToolbarAddBitmapStruct.hInst, EAX
	INVOKE	SendMessage, ToolbarHandle, TB_ADDBITMAP, $numToolbarButtons, OFFSET ToolbarAddBitmapStruct
	INVOKE	SendMessage, ToolbarHandle, TB_ADDBUTTONS, $numToolbarButtons, OFFSET ToolbarButtonStructs
	INVOKE	SendMessage, ToolbarHandle, TB_SETBUTTONSIZE, 0, $buttonWidth OR ($buttonHeight SHL 16)

; Now set up tooltip stuff:
; MSDN says this needs done, but it seems to work fine without it:
	INVOKE	SendMessage, ToolbarHandle, TB_SETMAXTEXTROWS, 0, 0	;Set text rows = 0.
	INVOKE	SendMessage, ToolbarHandle, TB_SETEXTENDEDSTYLE, 0, TBSTYLE_EX_MIXEDBUTTONS

; Get size of main & toolbar windows:
	INVOKE	GetClientRect, ToolbarHandle, ADDR gpRect
	INVOKE	GetClientRect, MainWinHandle, ADDR gpRect2
	MOV	EDX, gpRect2.bottom
	SUB	EDX, gpRect.bottom
; Use size to create child window:
	INVOKE	CreateWindowEx, 0, ADDR ChildClassName, NULL,
		$childWinAttrs, 0, gpRect2.bottom, gpRect2.right, EDX,
		MainWinHandle, NULL, hInst, NULL
	MOV	ChildWinHandle, EAX

; Bring to top of Z-order (this doesn't seem to help show the child window):
	INVOKE	SetWindowPos, ChildWinHandle, HWND_TOP, 0, 0, 0, 0, SWP_NOMOVE OR SWP_NOSIZE \
		OR SWP_SHOWWINDOW

	MOV	OK2paintFlag, TRUE			;Allow painting in child.
	
	invoke	GetDC, MainWinHandle
	push	eax
	INVOKE	TextOut, eax, 200, 200, offset MainText, 43
	pop	eax
	invoke	ReleaseDC, MainWinHandle, eax

;	INVOKE	InvalidateRect, ChildWinHandle, NULL, TRUE
	INVOKE	RedrawWindow, ChildWinHandle, NULL, NULL, RDW_INTERNALPAINT

	invoke	DrawCurve, MainWinHandle

;============= Message loop ===================
msgloop:
	INVOKE	GetMessage, ADDR msg, NULL, 0, 0
	OR	EAX, EAX				;EAX = 0 = exit
	JZ	exit99
	INVOKE	TranslateMessage, ADDR msg
	INVOKE	DispatchMessage, ADDR msg
	JMP	msgloop

exit99:
	MOV	EAX, msg.wParam
	RET

WinMain		ENDP


;====================================================================
; Main Window Proc
;====================================================================

MainWindowProc	PROC hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
		LOCAL gpRect:RECT, toolbarHeight:DWORD

	MOV	EAX, uMsg
	CMP	EAX, WM_SIZE
	JE	do_size
	CMP	EAX, WM_CLOSE
	JE	doclose
	CMP	EAX, WM_NOTIFY
	JE	do_notify

dodefault:
; use DefWindowProc for all other messages:
	INVOKE	DefWindowProc, hWin, uMsg, wParam, lParam
	RET

do_size:
	INVOKE	GetClientRect, ToolbarHandle, ADDR gpRect
	MOV	EAX, gpRect.bottom
	MOV	toolbarHeight, EAX
	MOVZX	EDX, WORD PTR lParam		;New window width.
; Resize toolbar:
	INVOKE	MoveWindow, ToolbarHandle, 0,  0, EDX, toolbarHeight, TRUE

; Resize child window:
	INVOKE	GetClientRect, MainWinHandle, ADDR gpRect
	MOV	EAX, gpRect.bottom
	SUB	EAX, toolbarHeight
	INVOKE	MoveWindow, ChildWinHandle, 0, toolbarHeight, gpRect.right, EAX, TRUE
	XOR	EAX, EAX
	RET

doclose:
	INVOKE	PostQuitMessage, NULL
	MOV	EAX, TRUE
	RET

do_notify:

; If this is a notification from a toolbar button control requesting tooltip
; info, the data sent will be in a NMTTDISPINFO structure, with a NMHDR structure
; at its head.

	MOV	EDX, lParam			;--> NMTTDISPINFO struct.
	CMP	[EDX + NMHDR.code], TTN_NEEDTEXT ;aka TTN_GETDISPINFO
	JNE	dodefault
	MOV	EAX, [EDX + NMHDR.idFrom]	;Could be the ID of one of our controls.
	CMP	EAX, $TBbutton1
	JB	dodefault
	CMP	EAX, $TBbutton8
	JA	dodefault

; At this point, we have a TTN_NEEDTEXT message for one of our buttons:
	SUB	EAX, $TBbutton1			;Get offset from 1st button ID:
	SHL	EAX, 2				;convert to DWORD offset
	MOV	EAX, [EAX + OFFSET ToolTipTextPtrs]
	MOV	[EDX + NMTTDISPINFO.lpszText], EAX	;Ptr. to tooltip text.
	MOV	[EDX + NMTTDISPINFO.uFlags], TTF_DI_SETITEM	;Don't bother me again!
	RET					;No particular return value needed.

MainWindowProc	ENDP


;====================================================================
; Child Window Proc
;====================================================================

ChildWindowProc	PROC hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
		LOCAL hDC:HDC, ps:PAINTSTRUCT

	MOV	EAX, uMsg
	CMP	EAX, WM_PAINT
	JE	do_paint

dodefault:
	INVOKE	DefWindowProc, hWin, uMsg, wParam, lParam
	RET

do_paint:
; Hold off painting until we're ready:
	CMP	OK2paintFlag, TRUE
	JNE	dodefault
	INVOKE	BeginPaint, hWin, ADDR ps
	MOV	hDC, EAX
	INVOKE	TextOut, hDC, 300, 300, offset ChildText, 34
	INVOKE	EndPaint, hWin, ADDR ps
	XOR	EAX, EAX
	RET

ChildWindowProc	ENDP


DrawCurve	PROC windowHandle:HANDLE
		LOCAL hDC:HDC, ps:PAINTSTRUCT
		LOCAL nLeftRect:DWORD, nTopRect:DWORD, nRightRect:DWORD, nBottomRect:DWORD
		LOCAL nXStartArc:DWORD, nYStartArc:DWORD, nXEndArc:DWORD, nYEndArc:DWORD
		LOCAL oldPen:DWORD, oldBrush:DWORD

	INVOKE	GetDC, windowHandle
	MOV	hDC, EAX
	INVOKE	GetStockObject, BLACK_PEN
	INVOKE	SelectObject, hDC, EAX
	MOV	oldPen, EAX

	MOV	nLeftRect, 100
	MOV	nTopRect,  280
	MOV	nRightRect, 400
	MOV	nBottomRect, 320
	MOV	nXStartArc, 400
	MOV	nYStartArc, 300
	MOV	nXEndArc, 100
	MOV	nYEndArc, 300

	INVOKE	Arc, hDC, nLeftRect, nTopRect, nRightRect, nBottomRect,
			nXStartArc, nYStartArc, nXEndArc, nYEndArc

	MOV	nTopRect,  285
	MOV	nBottomRect, 315

	INVOKE	Arc, hDC, nLeftRect, nTopRect, nRightRect, nBottomRect,
			nXStartArc, nYStartArc, nXEndArc, nYEndArc

	INVOKE	GetStockObject, BLACK_BRUSH
	INVOKE	SelectObject, hDC, EAX
	MOV	oldBrush, EAX

	INVOKE	FloodFill, hDC, 250, 282, 0

	INVOKE	SelectObject, hDC, oldPen
	INVOKE	SelectObject, hDC, oldBrush
	INVOKE	ReleaseDC, windowHandle, hDC

	RET	


DrawCurve	ENDP


;====================================================================
; CenterDim
;
; Returns half screen dimension (X or Y) minus half window dimension
;
; On entry,
;	EAX = screen dimension
;	EDX = window dimension
;
; Returns:
;	sdim/2 - wdim/2
;====================================================================

CenterDim	PROC

	SHR	EAX, 1				;divide screen dimension by 2
	SHR	EDX, 1				;divide window dimension by 2
	SUB	EAX, EDX
	RET					;Return w/# in EAX

CenterDim	ENDP


	END	start

